//
//  UIViewController+Children.swift
//  OverlayContainer
//
//  Created by Gaétan Zanella on 19/11/2018.
//

import UIKit

extension UIViewController {
    func addChild(_ child: UIViewController, in containerView: UIView) {
        guard containerView.isDescendant(of: view) else { return }
        addChild(child)
        containerView.addSubview(child.view)
        child.view.pinToSuperview()
        child.didMove(toParent: self)
    }

    func removeChild(_ child: UIViewController) {
        child.willMove(toParent: nil)
        child.view.removeFromSuperview()
        child.removeFromParent()
    }


    func oc_findPresentationController<Controller: UIPresentationController>(_ type: Controller.Type) -> Controller? {
        if let controller = presentationController as? Controller {
            return controller
        }
        return parent?.oc_findPresentationController(Controller.self)
    }
}
